/*
 * Copyright (c) 2018 - 2023, ETH Zurich, Computer Engineering Group (TEC)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
 * COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef __MAIN_H
#define __MAIN_H

/* Includes ------------------------------------------------------------------*/
#include <stdlib.h>
#include <string.h>
#include <stdint.h>
#include <stdbool.h>
#include <stdarg.h>

#include "config.h"

/* Defines -------------------------------------------------------------------*/

/* Determine hardware revision based on device ID */
#if (DPP_DEVICE_ID >= 22000) && (DPP_DEVICE_ID < 23000)
  #define GPP3X
  #if (DPP_DEVICE_ID >= 22010)
    #define GPP3X_REV_2_1
  #endif
#elif (DPP_DEVICE_ID >= 23000) || (DPP_DEVICE_ID < 21000)
  #error "invalid device ID"
#endif

/* Application Information */
#ifdef GPP3X
 #define INFO_FW_NAME           "GPP3x"
#else
 #define INFO_FW_NAME           "GPP1x"
#endif
#define INFO_MCU_DESC           "STM32L496VG"
#ifdef __GNUC__
  #define INFO_COMPILER_DESC    "GCC"
  #define INFO_COMPILER_VER     (__GNUC__ * 1000000 + __GNUC_MINOR__ * 1000 + __GNUC_PATCHLEVEL__)
#include "gitrev.h"   /* this file will be automatically generated by the pre-build step */
#endif
#ifndef INFO_FW_REV
  #define INFO_FW_REV           0
#endif /* INFO_FW_REV */

/* Misc */
#define TSYNC_MAX_PERIOD        65534           /* Max period for time sync over Bolt */
#define TSYNC_CHECK_MIN_VAL_S   1600000000      /* Lower limit for what is considered a valid timestamp (in seconds), only for timesync via Bolt */
#define TSYNC_USB_POLL_MS       10000           /* Polling interval for TSync task when TSYNC_USB is enabled */
#define BOLT_BUF_SIZE           (DPP_MSG_PKT_LEN + 2)
#define STREAMING_DATA_MAX_LEN  2048
#define SERIAL_PKT_MAX_LEN      (SERIAL_PKT_HDR_LEN + SERIAL_PKT_MAX_PAYLOAD + SERIAL_PKT_CRC_LEN)  /* Max. serial packet length (for binary transfer mode) */
#define SERIAL_PKT_HDR_LEN      12
#define SERIAL_PKT_CRC_LEN      4
#define SERIAL_PKT_MAX_PAYLOAD  2048
#define SERIAL_PKT_FRAME_BYTE   0x7e
#define SERIAL_PKT_ESC_BYTE     0x7d
#define USB_CDC_TIMEOUT_MS      20              /* Max. wait time if device is busy */
#define USE_LPUART1             (DBG_PRINT_TARGET_UART || STREAMING_TARGET_UART)
#define USE_USB_CDC             (DBG_PRINT_TARGET_USB || TSYNC_METHOD_USB || STREAMING_TARGET_USB)
#define BUZZER_TIME_ERROR_MS    1500
#define BUZZER_TIME_STARTUP_MS  300
#define BUZZER_TIME_USBMSC_MS   500
#define BUZZER_TIME_CMD_MS      200
#define BUZZER_TIME_TSYNC_MS    100
#define BUZZER_TIME_SLEEP_MS    150
#define RB_CMD_MAX_ITEM_LEN     (DPP_COMMAND_HDR_LEN + 12)

/* Application OpModes (bitwise!) */
#define SYS_OPMODE_TRG          (1 << 0)        /* Bit 1: Triggered mode */
#define SYS_OPMODE_SCHED        (1 << 1)        /* Bit 2: Scheduled mode */
#define SYS_OPMODE_CONT         (1 << 2)        /* Bit 3: Always-on (CONT) mode */
#define SYS_OPMODE_NOLEDS       (1 << 3)        /* Bit 4: Disable LEDs */
#define SYS_OPMODE_ALL          (SYS_OPMODE_TRG | SYS_OPMODE_SCHED | SYS_OPMODE_CONT | SYS_OPMODE_NOLEDS)

/* Task Execution for Scheduler, bitwise */
#define TASK_BITS               8               /* Number of task bits */
#define TASK_HEALTH             (1 << 0)        /* Bit 0: Health Task */
#define TASK_GEO                (1 << 1)        /* Bit 1: Geophone Task */
#define TASK_GNSS               (1 << 2)        /* Bit 2: GPS Task (raw data) */
#define TASK_INCLINO            (1 << 3)        /* Bit 3: Inclinometer Task */
#define TASK_TSYNC              (1 << 4)        /* Bit 4: TSync Task */
#define TASK_POSTPONE           (1 << 7)        /* Bit 7: Postpone one or multiple scheduled tasks */
#define TASK_ALL                (TASK_HEALTH | TASK_GEO | TASK_GNSS | TASK_INCLINO | TASK_TSYNC | TASK_POSTPONE)

/* Event Log Targets (bitwise) */
#define EVTLOG_SD               (1 << 0)        /* Bit 0: Write event log to the SD card */
#define EVTLOG_COM              (1 << 1)        /* Bit 1: Write event log to the COM board */
#define EVTLOG_ALL              (EVTLOG_SD | EVTLOG_COM)

/* Timesync Methods (use define instead of enum, otherwise precompiler cannot evaluate ifdefs) */
#define TSYNC_NONE              0
#define TSYNC_BOLT              1
#define TSYNC_GNSS              2
#define TSYNC_USB               3
#define TSYNC_METHOD_NONE       (TSYNC_METHOD == TSYNC_NONE)
#define TSYNC_METHOD_BOLT       (TSYNC_METHOD == TSYNC_BOLT)
#define TSYNC_METHOD_GNSS       (TSYNC_METHOD == TSYNC_GNSS)
#define TSYNC_METHOD_USB        (TSYNC_METHOD == TSYNC_USB)
#define TSYNC_METHOD_VALID      (TSYNC_METHOD_NONE || TSYNC_METHOD_BOLT || TSYNC_METHOD_GNSS || TSYNC_METHOD_USB)

/* Debug Print Targets */
#define DBG_PRINT_NONE          0
#define DBG_PRINT_SWO           1
#define DBG_PRINT_USB           2
#define DBG_PRINT_UART          3
#define DBG_PRINT_STREAM        4
#define DBG_PRINT_TARGET_NONE   (DEBUG_PRINT_TARGET == DBG_PRINT_NONE)
#define DBG_PRINT_TARGET_SWO    (DEBUG_PRINT_TARGET == DBG_PRINT_SWO)
#define DBG_PRINT_TARGET_USB    (DEBUG_PRINT_TARGET == DBG_PRINT_USB)
#define DBG_PRINT_TARGET_UART   (DEBUG_PRINT_TARGET == DBG_PRINT_UART)
#define DBG_PRINT_TARGET_STREAM (DEBUG_PRINT_TARGET == DBG_PRINT_STREAM)
#define DBG_PRINT_TARGET_VALID  (DBG_PRINT_TARGET_NONE || DBG_PRINT_TARGET_SWO || DBG_PRINT_TARGET_USB || DBG_PRINT_TARGET_UART || DBG_PRINT_TARGET_STREAM)

/* Streaming Targets */
#define STREAMING_NONE          0
#define STREAMING_SWO           1
#define STREAMING_USB           2
#define STREAMING_UART          3
#define STREAMING_TARGET_NONE   (STREAMING_TARGET == STREAMING_NONE)
#define STREAMING_TARGET_SWO    (STREAMING_TARGET == STREAMING_SWO)
#define STREAMING_TARGET_USB    (STREAMING_TARGET == STREAMING_USB)
#define STREAMING_TARGET_UART   (STREAMING_TARGET == STREAMING_UART)
#define STREAMING_TARGET_VALID  (STREAMING_TARGET_NONE || STREAMING_TARGET_SWO || STREAMING_TARGET_USB || STREAMING_TARGET_UART)


/* Enumerations --------------------------------------------------------------*/
typedef enum
{
    DBG_LVL_ERROR   = 0,
    DBG_LVL_WARNING = 1,
    DBG_LVL_INFO    = 2,
    DBG_LVL_VERBOSE = 3,
    NUM_DBG_LVL     = 4
} DebugLevel_t;

typedef enum
{
    BOLT_ERR_OK = 0,
    BOLT_ERR_RD_START_ACK,
    BOLT_ERR_RD_ACK,
    BOLT_ERR_RD_BUF_OV,
    BOLT_ERR_RD_BUF_LEN,
    BOLT_ERR_RD_HDR_LEN,
    BOLT_ERR_RD_PAYLOAD_LEN,
    BOLT_ERR_RD_CMD_LEN,
    BOLT_ERR_WR_ACK,
    BOLT_ERR_WR_SPI_HAL,
    BOLT_ERR_WR_SPI_ACK,
    BOLT_ERR_WR_END_ACK,
    BOLT_ERR_RD_CRC,
    BOLT_ERR_RD_MSG_TYPE,
    BOLT_ERR_RD_SPI_HAL,
    NUM_OF_BOLT_ERR_TYPES
} BoltErrType_t;

typedef enum                                /* SD Card Log Types */
{
    LOGTYPE_NONE = 0,
    LOGTYPE_SD_MOUNT,                       /* Mount SD card command */
    LOGTYPE_SD_EJECT,                       /* Eject SD card command */
    LOGTYPE_SD_GETSIZE,                     /* Get SD card size */
    LOGTYPE_SD_PREVENTCHGDIR,               /* Set PreventChangeDirectory flag */
    LOGTYPE_SD_ALLOWCHGDIR,                 /* Restore PreventChangeDirectory flag */
    LOGTYPE_CONF_RD,                        /* Read config from SD card */
    LOGTYPE_CONF_WR,                        /* Write config to SD card */
    LOGTYPE_ADC1_CHUNK,                     /* Log ADC1 data chunk */
    LOGTYPE_ADC2_CHUNK,                     /* Log ADC2 data chunk */
    LOGTYPE_ADC3_CHUNK,                     /* Log ADC3 data chunk */
    LOGTYPE_ACQ,                            /* Log ACQ entry */
    LOGTYPE_EVENT,                          /* Log EVENT entry */
    LOGTYPE_HEALTH,                         /* Log HEALTH entry */
    LOGTYPE_IMUSTAT,                        /* Log IMU entry */
    LOGTYPE_INCLINO,                        /* Log Inclino entry */
    LOGTYPE_IMUDATA,                        /* Log IMU data */
    LOGTYPE_SCHED_CLEAR,                    /* Delete schedule data from the SD card */
    LOGTYPE_SCHED_ADD,                      /* Add schedule entry to the SD card */
    LOGTYPE_GNSS,                           /* Log GNSS data */
    LOGTYPE_COMDATA,                        /* Data received from COM processor for logging to SD card */
    LOGTYPE_USB_MSC_MOUNT,                  /* Mount USB mass storage device */
    LOGTYPE_USB_MSC_EJECT,                  /* Eject USB mass storage device */
    LOGTYPE_USB_CDC_INIT,                   /* Init USB device in CDC mode */
    LOGTYPE_TSYNC,
    NUM_OF_LOGTYPES
} LogType_t;

typedef enum                                /* Log Error Types */
{
    LOG_ERR_OK = 0,
    LOG_ERR_INVALID,                        /* 01 */
    LOG_ERR_MOUNT,                          /* 02 */
    LOG_ERR_DIR,                            /* 03 */
    LOG_ERR_FSTAT,                          /* 04 */
    LOG_ERR_FOPEN,                          /* 05 */
    LOG_ERR_FCREATE,                        /* 06 */
    LOG_ERR_FWRITE,                         /* 07 */
    LOG_ERR_FWRITE_NUM,                     /* 08 */
    LOG_ERR_UNUSED,                         /* 09 */
    LOG_ERR_FSEEK,                          /* 10 */
    LOG_ERR_MSEED,                          /* 11 */
    LOG_ERR_BUFFER,                         /* 12 */
    LOG_ERR_FWRITE_OFS,                     /* 13 */
    LOG_ERR_NOTIFY,                         /* 14 */
    LOG_ERR_INV_DATA,                       /* 15 */
    NUM_OF_LOG_ERR_TYPES
} LogErrType_t;

typedef enum
{
    GNSS_ERR_NONE = 0,
    GNSS_ERR_RXBUFFER_OVF,
    GNSS_ERR_UART_DMA,
    GNSS_ERR_MSG_LEN,
    GNSS_ERR_MSG_HDR,
    GNSS_ERR_NAK,
    GNSS_ERR_WARNING,
} GNSSError_t;

typedef enum
{
    SERIAL_PKT_INVALID = 0,
    SERIAL_PKT_ADC1_RAW,
    SERIAL_PKT_ADC2_RAW,
    SERIAL_PKT_ADC3_RAW,
    SERIAL_PKT_ADC_MINISEED,
    SERIAL_PKT_DEBUG_MSG,
    SERIAL_PKT_APP_HEALTH,
    NUM_SERIAL_PKT_TYPES,
} SerialPacketType_t;

typedef enum
{
    STREAMING_DTYPE_GEO_A1 = 0,
    STREAMING_DTYPE_GEO_A2,
    STREAMING_DTYPE_GEO_A3,
    STREAMING_DTYPE_DEBUG,
    STREAMING_DTYPE_HEALTH,
    NUM_STREAMING_DTYPES,
} StreamingDataType_t;

typedef enum
{
    GEO_ACQSTATUS_STOPPED = 0,
    GEO_ACQSTATUS_ACTIVE = 1,
    GEO_ACQSTATUS_ABORT = 2,
} GeoAcqStatus_t;

typedef enum
{
    /* Note: enum values must match the corresponding column indices of the table geo_trg_bias */
    GEO_TRG_BIAS_DEV_ID = 0,
    GEO_TRG_BIAS_STAGE1,
    GEO_TRG_BIAS_STAGE2,
    GEO_TRG_BIAS_NEG_TH,
    GEO_TRG_BIAS_POS_TH,
    NUM_GEO_TRG_BIAS,
} GeoTrgBias_t;

/* Structures ----------------------------------------------------------------*/
typedef struct                              /* System health status */
{
    uint32_t Uptime;                        /* Uptime [sec] */
    uint16_t Vbat;                          /* Battery voltage [mV] */
    uint16_t Vref;                          /* System VRef [mV] */
    uint16_t DutyCycle;                     /* System duty cycle [10^-2 %] */
    int16_t  CoreTemp;                      /* Core temperature [10^-2 degC] */
    int16_t  Temperature;                   /* Temperature [10^-2 degC] */
    uint16_t Humidity;                      /* Humidity [10^-2 %] */
    uint8_t  StackUsage;                    /* Highest stack WM [%] */
    uint8_t  HeapUsedP;                     /* Heap usage [%] */
    uint8_t  StackTmrSvcWMP;                /* Timer Daemon task stack WM [%] */
    uint8_t  StackIdleWMP;                  /* Idle task stack WM [%] */
    uint8_t  SelfTestResult;                /* Self-test result */
    uint32_t CmdCnt;                        /* Command count */
    uint32_t ResetCnt;                      /* Reset count */
    uint8_t  ResetFlags;                    /* Reset flags */
    bool     ConfigFromSD;                  /* Whether the config was loaded from the SD card */
} SysHealth_t;

typedef struct                              /* ADC Acquire Struct */
{
    uint64_t Start;                         /* Start timestamp [us] */
    uint64_t End;                           /* End timestamp [us] */
    uint64_t First;                         /* First ADC sample timestamp [us] */
    uint32_t ID;                            /* Acquire # Identifier */
    uint32_t Samples;                       /* Number of samples in total */
    uint32_t Samples_TrgADC;                /* Number of samples at the ADC that is connected to the trigger */
    uint32_t PeakPosVal;                    /* Positive peak value (can be pos or neg!) of ADC during Acq */
    uint32_t PeakPosSampleNo;               /* Positive peak location: sample no. of peak value of ADC */
    uint32_t PeakNegVal;                    /* Negative peak value (can be pos or neg!) of ADC during Acq */
    uint32_t PeakNegSampleNo;               /* Negative peak location: sample no. of peak value of ADC */
    uint32_t TrgCountPos;                   /* Count of positive TRGs during Acq */
    uint32_t TrgCountNeg;                   /* Count of negative TRGs during Acq */
    uint32_t TrgLastPosSampleNo;            /* Last positive TRG location: sample no. of ADC */
    uint32_t TrgLastNegSampleNo;            /* Last negative TRG location: sample no. of ADC */
    uint16_t TrgThPos;                      /* Positive TRG threshold [mV] */
    uint16_t TrgThNeg;                      /* Negative TRG threshold [mV] */
    uint16_t TrgGain;                       /* TRG gain (see TRGGainStage_t enum) */
    uint16_t ChunksSampled;                 /* Number of Chunks sampled */
    uint16_t ChunksRemaining;               /* Number of Chunks remaining to be sampled */
    uint16_t PostTrg;                       /* Acquire post-trigger [# of ADC chunks to be sampled after last TRG] */
    uint16_t Timeout;                       /* Acquire timeout [maximum # of ADC chunks to be sampled overall] */
    uint16_t SPS;                           /* ADC samples per second [sps] */
    uint8_t  PGA;                           /* ADC PGA value */
    uint8_t  Format;                        /* ADC data format (see ADCFormatType_t enum) */
    uint8_t  TrgSource;                     /* TRG that initiated the acquisition (see TRGTypes enum) */
    uint8_t  Status;                        /* Acquisition status (see GeoAcqStatus_t enum) */
} Geophone_t;

typedef struct                              /* IMU: status */
{
    uint64_t Start;                         /* Start timestamp [us] */
    uint32_t ID;                            /* IMU # Identifier (same as Acquire ID) */
    uint16_t Samples_PreTrg;                /* # samples before trigger */
    uint16_t Samples_PostTrg;               /* # samples after  trigger */
    uint16_t Freq_LP;                       /* Low  Power ODR (10,50,100,200,400,800) [Hz] */
    uint16_t Freq_HP;                       /* High Power ODR (10,50,100,200,400,800) [Hz] */
    uint16_t Freq_AA;                       /* Anti aliasing mode (0,50,100,200,400) [Hz] */
    uint8_t  OpMode;                        /* Operation mode (ImuOperationTypes, task_imu.c) */
    uint8_t  Level_Trg;                     /* Trigger level [1/64g] */
    uint8_t  Decimation;                    /* Data decimation factor (number of samples to average over) */
    uint8_t  Status;                        /* IMU status. 1: Imu is active | 0: Imu is stopped */
} ImuStat_t;

typedef struct                              /* IMU: data */
{
    uint32_t ID;                            /* Associated ImuStat_t ID */
    uint16_t acc_x;                         /* Accelerometer X-axis raw data */
    uint16_t acc_y;                         /* Accelerometer Y-axis raw data */
    uint16_t acc_z;                         /* Accelerometer Z-axis raw data */
    uint16_t mag_x;                         /* Magnetometer X-axis raw data */
    uint16_t mag_y;                         /* Magnetometer Y-axis raw data */
    uint16_t mag_z;                         /* Magnetometer Z-axis raw data */
} ImuData_t;

typedef struct                              /* INCLINO: status */
{
    uint64_t Current_Timestamp;             /* Timestamp when measured [us]*/
    uint32_t ID;                            /* Inclinometer # Identifier (same as Acquire ID) */
    uint32_t Samples;                       /* Number of samples in total */
    uint8_t  Status;                        /* Inclinometer status. 1: Inclinometer is active | 0: Inclinometer is in power down */
} InclinoStat_t;

typedef struct                              /* GNSS Struct */
{
    uint32_t last_sync_ts;                  /* UNIX timestamp of the last sync */
    uint8_t* rx_buf;                        /* Pointer to the GNSS received data buffer (used by the GNSS task). */
    uint8_t* dma_buf;                       /* Pointer to the GNSS buffer for DMA UART RX. */
    uint16_t dma_cntr;                      /* Counter used by the DMA callback */
    uint16_t rx_len;                        /* Length of message in GNSS Rx data buffer */
    uint16_t tpulse_cnt;                    /* Number of received time pulses */
    uint8_t  state;                         /* GNSS state */
    int8_t   leap_s;                        /* Leap Seconds to subtract from GPS time to determine UTC time (will be determined automatically) */
} GNSSStat_t;

typedef struct
{
    uint64_t rcvd_timestamp;                /* Received UNIX timestamp [us] */
    uint64_t rtc_timestamp;                 /* Current UNIX timestamp from the RTC (at the time when the tsync task was executed) [us] */
    uint64_t uptime;                        /* RTC uptime [ms] */
    int32_t  offset;                        /* Estimated RTC offset before the RTC update [us] */
    uint16_t duration;                      /* How long it took to obtain the timestamp [s] */
    int8_t   drift_estimated;               /* Estimated drift before RTC update [ppm] */
    int8_t   drift_comp;                    /* Applied drift compensation [ppm] */
} TSyncInfo_t;

typedef struct                              /* Schedule entry struct */
{
    uint32_t first;                         /* First occurrence of the measurement (s) */
    uint32_t period;                        /* Period of the measurement (s) */
    uint32_t argument;                      /* Task-specific argument */
    uint8_t  tasks;                         /* Tasks which should be executed (bit mask) */
} ScheduleEntry_t;

typedef struct __attribute__((__packed__))  /* Serial interface packet (for binary data transfer via a serial port) */
{
    SerialPacketType_t type : 8;            /* Message type */
    uint8_t            padding;             /* Padding byte, for future use */
    uint16_t           seq_no;              /* Sequence number */
    uint16_t           offset;              /* For larger files: offset of the current payload from the start of the file, in bytes */
    uint16_t           payload_len;         /* Payload length */
    uint32_t           arg;                 /* Argument, depends on the type */
    uint8_t            payload[SERIAL_PKT_MAX_PAYLOAD + SERIAL_PKT_CRC_LEN];   /* Payload and CRC */
} SerialPacket_t;

typedef struct
{
    uint32_t            arg;
    uint16_t            len;
    StreamingDataType_t type : 8;
    uint8_t             data[STREAMING_DATA_MAX_LEN];
} StreamingData_t;

/* Project Includes ----------------------------------------------------------*/
#include "stm32l4xx.h"
#include "stm32l4xx_hal.h"
#include "bsp_driver_sd.h"
#include "usb_device.h"
#include "arm_math.h"
#include "ffconf.h"
#include "dpp_message.h"
#include "dpp_lib.h"
#include "rb.h"
#include "hardware.h"
#include "calibration.h"
#include "adc.h"
#include "dac.h"
#include "gnss.h"
#if   defined(LSM303_C)
  #include "lsm303c.h"
#elif defined(LSM303_AGR)
  #include "lsm303agr.h"
#else
  #error "IMU not correctly defined"
#endif
#include "mseed.h"
#include "psd.h"
#include "rtc.h"
#include "rtos.h"
#include "scl3300.h"
#include "sd.h"
#include "sht31.h"
#include "tl.h"

/* Macros --------------------------------------------------------------------*/
#define S_TO_MS(t)              ((t) * 1000)
#define MS_TO_S(t)              ((t) / 1000)
#define MS_TO_US(t)             ((t) * 1000)
#define S_TO_US(t)              ((t) * 1000000)
#define US_TO_S(t)              ((t) / 1000000)
#define US_TO_MS(t)             ((t) / 1000)
#define US_TO_NS(t)             ((t) * 1000)
#define WEEKS_TO_S(w)           ((w) * 604800)

#ifndef BINARY
#define BINARY(N)               ((((N) >> 7) & 0b1) * 10000000 + \
                                 (((N) >> 6) & 0b1) *  1000000 + \
                                 (((N) >> 5) & 0b1) *   100000 + \
                                 (((N) >> 4) & 0b1) *    10000 + \
                                 (((N) >> 3) & 0b1) *     1000 + \
                                 (((N) >> 2) & 0b1) *      100 + \
                                 (((N) >> 1) & 0b1) *       10 + \
                                 ((N) & 0b1))
#endif

#define DIGIT(s, no)            ((s)[no] - '0')

#if (USE_SYSTEMVIEW)
#define __ISR_ENTER()           traceISR_ENTER()
#define __ISR_EXIT()            if (SCB->ICSR & SCB_ICSR_PENDSVSET_Msk) { traceISR_EXIT_TO_SCHEDULER(); } \
                                else { traceISR_EXIT(); }
#elif DEBUG_MONITOR_ISR_RUNTIME
#define __ISR_ENTER()           uint32_t cntr = TIM5_getCounterValue()
#define __ISR_EXIT()            if ( (TIM5_getCounterValue() - cntr) > 2 ) { DEBUG_PRINT(DBG_LVL_WARNING, "ISR runtime exceeds 1ms"); }
#else
#define __ISR_ENTER()           /* do nothing */
#define __ISR_EXIT()            /* do nothing */
#endif /* USE_SYSTEMVIEW */

#define __FILE_BASENAME__       (strrchr(__FILE__, '/') ? (strrchr(__FILE__, '/') + 1) : (__FILE__))

#if !DBG_PRINT_TARGET_NONE
  #define DEBUG_PRINT(level, msg)   if (DEBUG_OUTPUT_LEVEL >= (level)) DebugPrint(__FILE_BASENAME__, __LINE__, level, msg)
  #define DEBUG_PRINTF(level, ...)  if (DEBUG_OUTPUT_LEVEL >= (level)) DebugPrintf(__FILE_BASENAME__, __LINE__, level, __VA_ARGS__)
#else
  #define DEBUG_PRINT(level, msg)
  #define DEBUG_PRINTF(level, ...)
#endif

#define SWO_SEND(data, len)     _write(0, (uint8_t*)data, len)

#define Error_Handler()         Application_errorHandler(__FILE_BASENAME__, __LINE__)
#define Error_Handler_Idle()    RTOS_errorHandlerInIdle(__FILE_BASENAME__, __LINE__)   /* Tell idle task to enter error handler (can be used to let all currently running tasks finish) */

#if USE_BUZZER
  #define ERROR_INDICATION()    LED_R_ON(); BUZZER(BUZZER_TIME_ERROR_MS); LED_R_OFF()
#else
  #define ERROR_INDICATION()    LED_R_ON(); HAL_Delay(BUZZER_TIME_ERROR_MS); LED_R_OFF()
#endif

/* Config Checks -------------------------------------------------------------*/
/* Must be after everything has been defined */
#if DBG_PRINT_TARGET_USB && USE_STOP2
#error "Cannot use DEBUG_PRINT_USB with STOP2 mode"
#endif
#if TSYNC_METHOD_USB && (USE_STOP2 || USE_TICKLESS_IDLE)
#error "TSYNC_USB requires USE_STOP2 = 0 and USE_TICKLESS_IDLE = 0"
#endif
#if WATCHDOG_TIMEOUT && ((SYSTEM_WAKEUP_PERIOD > WATCHDOG_TIMEOUT) || !SYSTEM_WAKEUP_PERIOD || (ADC_SYNC_PERIOD > WATCHDOG_TIMEOUT))
#error "SYSTEM_WAKEUP_PERIOD too high, Watchdog timer needs to be reset every WATCHDOG_TIMEOUT seconds"
#endif
#if !BOLT_ENABLE && TSYNC_METHOD_BOLT
#error "TSYNC_BOLT requires BOLT_ENABLE = 1"
#endif
#if GEO_NUM_AXES > 3 || GEO_NUM_AXES < 1
#error "GEO_NUM_AXES must be 1, 2 or 3"
#endif
#if !defined(TSYNC_METHOD) || !TSYNC_METHOD_VALID
#error "Invalid TSYNC_METHOD"
#endif
#if !defined(DEBUG_PRINT_TARGET) || !DBG_PRINT_TARGET_VALID || (DBG_PRINT_TARGET_STREAM && STREAMING_TARGET_NONE)
#error "Invalid DEBUG_PRINT_TARGET"
#endif
#if !defined(STREAMING_TARGET) || !STREAMING_TARGET_VALID
#error "Invalid STREAMING_TARGET"
#endif
#if DEBUG_USB_MSC_ON_DBGPIN2 && DBG_PRINT_TARGET_UART
#error "Cannot use DEBUG_USB_MSC_ON_DBGPIN2 with DBG_PRINT_TARGET_UART"
#endif
#if (DBG_PRINT_TARGET_UART && STREAMING_TARGET_UART) || (DBG_PRINT_TARGET_USB && STREAMING_TARGET_USB) || (DBG_PRINT_TARGET_SWO && STREAMING_TARGET_SWO)
#error "Debug print target and streaming target cannot be the same"
#endif
#if LOG_TASK_BUFFERED_MSEED && !MSEED_USE_COMPRESSION
#error "Buffered mseed write is only available when compression is enabled"
#endif
#if !STREAMING_TARGET_NONE && (LOG_ADCDATA_MINISEED && !LOG_TASK_BUFFERED_MSEED)
#error "Streaming in miniSEED format required LOG_TASK_BUFFERED_MSEED"
#endif
#if (LOG_ADCDATA_DOWNSAMPLE_FREQ && !LOG_ADCDATA_MINISEED) || (LOG_ADCDATA_DOWNSAMPLE_FREQ > ADC_SPS)
#error "Invalid value for LOG_ADCDATA_DOWNSAMPLE_FREQ"
#endif
#if (GEO_TRG_NEG_TH >= GEO_TRG_POS_TH) || (GEO_TRG_POS_TH >= DAC_VREF)
#error "Invalid trigger threshold values"
#endif
#if TSYNC_MASTER && TSYNC_METHOD_BOLT
#error "Cannot use TSYNC_METHOD_BOLT with TSYNC_MASTER"
#endif
/* Remark: allow the period to be slightly shorter than the sample time to ensure that continuous sampling is possible */
#if GNSS_PERIOD_S && ( (GNSS_PERIOD_S + SYSTEM_WAKEUP_PERIOD) < GNSS_NUM_OF_SAMPLES )
#error "Invalid value for GNSS_PERIOD_S"
#endif
#if TSYNC_PERIOD_S < 60 || TSYNC_FALLBACK_PERIOD_S < TSYNC_PERIOD_S
#error "Invalid TSYNC period configuration"
#endif
#if LOG_PSD_AVG_PERIOD_S < 60
#error "LOG_PSD_AVG_PERIOD_S is too small"
#endif
#if GEO_WAIT_FOR_TSYNC && TSYNC_METHOD_NONE
#error "GEO_WAIT_FOR_TSYNC requires timesync"
#endif

/* Global variables ----------------------------------------------------------*/
typedef struct                              /* System configuration */
{
    uint16_t              DeviceID;         /* Device ID */
    bool                  ComBoard;         /* Whether the ComBoard is plugged in */
    uint8_t               OpMode;           /* Application operating mode */
    const SysHealth_t*    SysHealth;        /* Read-only pointer to the system health info */
    const USB_t*          USB;              /* Read-only pointer to the USB info */
    const Geophone_t*     Geo;              /* Read-only pointer to the Geophone info */
    const GNSSStat_t*     GNSS;             /* Read-only pointer to the GNSS info */
    const InclinoStat_t*  Inclino;          /* Read-only pointer to the Inclinometer info */
    const ImuStat_t*      Imu;              /* Read-only pointer to the IMU info */
} SysConf_t;

extern SysConf_t SysConf;

/* Functions -----------------------------------------------------------------*/
void    Application_init(void);
void    Application_reset(void);
void    Application_setConfigDefault(void);
void    Application_errorHandler(char* file, int line);
void    Deployment_init(void);

void    DebugPrint(const char *filename, uint16_t lineno, DebugLevel_t level, const char *msg);
void    DebugPrintf(const char *filename, uint16_t lineno, DebugLevel_t level, const char *msg, ...);
void    Delay(volatile uint32_t us);

/* Defined in scheduler.c */
bool    Schedule_addEntry(uint8_t tasks, uint32_t start_time, uint32_t period, uint32_t arg, bool persistent);
bool    Schedule_adjustTaskPeriod(uint8_t task, uint32_t new_period);
bool    Schedule_postponeTask(uint8_t task, uint32_t duration_s);
void    Schedule_clear(bool addDefaultTasks);

/* Defined in task_bolt.c */
#if BOLT_ENABLE
bool    Bolt_checkComBoard(void);
bool    Bolt_enqueueMessage(dpp_message_type_t type, const uint8_t* payload);
bool    Bolt_enqueueMessageEx(dpp_message_type_t type, const uint8_t* payload, uint32_t payload_len);
bool    Bolt_sendEvent(dpp_event_type_t type, uint32_t value, bool force);
#else
#define Bolt_checkComBoard()        false
#define Bolt_enqueueMessage(t, p)
#endif

/* Defined in task_tsync.c */
void    TSync_timeout(void);
void    TSync_capture(void);
void    TSync_setNextEpoch(uint32_t next_epoch);
void    TSync_setTimestamp(uint64_t ts_us);

/* Defined in test_hw.c */
bool    SelfTest_quick(void);
void    SelfTest_full(void);
void    SelfTest_geophone(void);

/* Defined in task_geo.c */
void    Geo_enableTrigger(void);
void    Geo_disableTrigger(void);
bool    Geo_setTriggerThresholds(uint16_t positive, uint16_t negative);
void    Geo_initAcq(TRGType_t trg, uint32_t duration, BaseType_t* const pxHigherPriorityTaskWoken);   // if duration is zero, continuous mode will be enabled
void    Geo_abort(bool restart);

/* Defined in task_imu.c */
uint32_t Imu_getOrientation(bool swOff);

int     _write(int32_t file, uint8_t *ptr, int32_t len);

#endif /* __MAIN_H */

